<?php

declare(strict_types = 1);

namespace Drupal\group_finder\Plugin\GroupFinder;

use Drupal\group\Entity\GroupInterface;
use Drupal\group\Entity\GroupTypeInterface;
use Drupal\group_finder\GroupFinderBase;

/**
 * Plugin for create new group.
 *
 * @GroupFinder(
 *   id = "create_group",
 *   label = @Translation("Create group"),
 *   description = @Translation("When in context of creating new group"),
 *   weight = 0,
 * )
 */
class CreateGroup extends GroupFinderBase {

  /**
   * {@inheritdoc}
   */
  public function isApplicable(): bool {
    $route = $this->routeMatch->getRouteObject();
    return $route
      && $route->getOption('_group_operation_route')
      && isset($route->getDefaults()['_entity_form'])
      && $route->getDefaults()['_entity_form'] === 'group.add';
  }

  /**
   * {@inheritdoc}
   */
  public function getGroup(): ?GroupInterface {
    return NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function getGroupType(): ?GroupTypeInterface {
    return $this->routeMatch->getParameter('group_type');
  }

}
